<!--
  @component
  Generates an SVG x-axis. This component is also configured to detect if your x-scale is an ordinal scale. If so, it will place the markers in the middle of the bandwidth.
  -->
<script>
  import { getContext } from 'svelte';
  import { textWrap } from 'd3plus';
  const { padding, width, height, xScale, yRange } = getContext('LayerCake');

  /** @type {Boolean} [gridlines=true] - Extend lines from the ticks into the chart space */
  export let gridlines = true;

  /** @type {Boolean} [tickMarks=false] - Show a vertical mark for each tick. */
  export let tickMarks = false;

  /** @type {Boolean} [baseline=false] - Show a solid line at the bottom. */
  export let baseline = false;

  /** @type {Boolean} [snapTicks=false] - Instead of centering the text on the first and the last items, align them to the edges of the chart. */
  export let snapTicks = false;

  /** @type {Function} [formatTick=d => d] - A function that passes the current tick value and expects a nicely formatted value in return. */
  export let formatTick = (d) => d;

  /** @type {Number|Array|Function} [ticks] - If this is a number, it passes that along to the [d3Scale.ticks](https://github.com/d3/d3-scale) function. If this is an array, hardcodes the ticks to those values. If it's a function, passes along the default tick values and expects an array of tick values in return. If nothing, it uses the default ticks supplied by the D3 function. */
  export let ticks = undefined;

  /** @type {Number} [xTick=0] - How far over to position the text marker. */
  export let xTick = 0;

  /** @type {Number} [yTick=16] - The distance from the baseline to place each tick value. */
  export let yTick = 16;

  /** @type {String|Array<string>|Null} [title=blah] - Title of axis, ensure enough margin. */
  export let title = null;

  /** @type {Boolean} [titleTop=false] - Place the title on the top or bottom. */
  export let titleTop = false;

  const lineWidth = 15;
  $: titleTranslation = titleTop ? 0 - $padding.top : $height + ($padding.bottom - lineWidth);
  $: isBandwidth = typeof $xScale.bandwidth === 'function';

  $: tickValues = Array.isArray(ticks)
    ? ticks
    : isBandwidth
    ? $xScale.domain()
    : typeof ticks === 'function'
    ? ticks($xScale.ticks())
    : $xScale.ticks(ticks);

  function textAnchor(i) {
    if (snapTicks === true) {
      if (i === 0) {
        return 'start';
      }
      if (i === tickValues.length - 1) {
        return 'end';
      }
    }
    return 'middle';
  }
</script>

<g class="axis x-axis" class:snapTicks>
  {#each tickValues as tick, i (tick)}
    {@const colWidth = isBandwidth ? $xScale.bandwidth() / 2 + xTick : xTick}
    <g class="tick tick-{i}" transform="translate({$xScale(tick)},{Math.max(...$yRange)})">
      {#if gridlines !== false}
        <line class="gridline" y1={$height * -1} y2="0" x1="0" x2="0" />
      {/if}
      {#if tickMarks === true}
        <line
          class="tick-mark"
          y1={0}
          y2={6}
          x1={isBandwidth ? $xScale.bandwidth() / 2 : 0}
          x2={isBandwidth ? $xScale.bandwidth() / 2 : 0}
        />
      {/if}
      <text class="wrapped-text" x={colWidth} y={yTick} dx="" dy="" text-anchor={textAnchor(i)}>
        {#each textWrap().width($xScale.bandwidth() - 2)(formatTick(tick)).lines as line, ln}
          <tspan x={colWidth} dy={ln ? 15 : 0}>{line}</tspan>
        {/each}
      </text>
    </g>
  {/each}
  {#if baseline === true}
    <line class="baseline" y1={$height + 0.5} y2={$height + 0.5} x1="0" x2={$width} />
  {/if}
  {#if title}
    <g class="AxisTitle">
      {#if typeof title == 'string'}
        <text transform="translate({$width / 2}, {titleTranslation})">{title}</text>
      {:else if title.constructor === Array}
        {#each title as line, i}
          <text transform="translate({$width / 2}, {titleTranslation + i * lineWidth})">{line}</text>
        {/each}
      {/if}
    </g>
  {/if}
</g>

<style>
  .AxisTitle text {
    fill: #c0c0c0;
    font-size: 1em;
    font-family: 'Unica One', sans-serif;
    font-weight: bold;
    text-anchor: middle;
  }

  .tick {
    font-size: 0.725em;
    font-weight: 200;
  }

  line,
  .tick line {
    stroke: #aaa;
    stroke-dasharray: 2;
  }

  .tick text {
    fill: #e0e0e0;
    font-size: 1.2em;
    font-weight: bold;
    font-family: 'Unica One', sans-serif;
    font-weight: bold;
    /* stroke: #000000;
    stroke-width: 1px;
    stroke-linejoin: round; */
  }

  .tick .tick-mark,
  .baseline {
    stroke-dasharray: 0;
  }
  /* This looks slightly better */
  .axis.snapTicks .tick:last-child text {
    transform: translateX(3px);
  }
  .axis.snapTicks .tick.tick-0 text {
    transform: translateX(-3px);
  }
</style>
